]> git.proxmox.com Git - mirror_qemu.git/blob - configure
5227421231038f00c611ee4d17f15fe2fe27717b
[mirror_qemu.git] / configure
1 #!/bin/sh
2 #
3 # qemu configure script (c) 2003 Fabrice Bellard
4 #
5
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does. Unlike autoconf, we assume that unset exists.
8 unset CLICOLOR_FORCE GREP_OPTIONS BASH_ENV ENV MAIL MAILPATH CDPATH
9
10 # Don't allow CCACHE, if present, to use cached results of compile tests!
11 export CCACHE_RECACHE=yes
12
13 # make source path absolute
14 source_path=$(cd "$(dirname -- "$0")"; pwd)
15
16 if test "$PWD" = "$source_path"
17 then
18 echo "Using './build' as the directory for build output"
19
20 MARKER=build/auto-created-by-configure
21
22 if test -e build
23 then
24 if test -f $MARKER
25 then
26 rm -rf build
27 else
28 echo "ERROR: ./build dir already exists and was not previously created by configure"
29 exit 1
30 fi
31 fi
32
33 if ! mkdir build || ! touch $MARKER
34 then
35 echo "ERROR: Could not create ./build directory. Check the permissions on"
36 echo "your source directory, or try doing an out-of-tree build."
37 exit 1
38 fi
39
40 cat > GNUmakefile <<'EOF'
41 # This file is auto-generated by configure to support in-source tree
42 # 'make' command invocation
43
44 ifeq ($(MAKECMDGOALS),)
45 recurse: all
46 endif
47
48 .NOTPARALLEL: %
49 %: force
50 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
51 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
52 @if test "$(MAKECMDGOALS)" = "distclean" && \
53 test -e build/auto-created-by-configure ; \
54 then \
55 rm -rf build GNUmakefile ; \
56 fi
57 force: ;
58 .PHONY: force
59 GNUmakefile: ;
60
61 EOF
62 cd build
63 exec "$source_path/configure" "$@"
64 fi
65
66 # Temporary directory used for files created while
67 # configure runs. Since it is in the build directory
68 # we can safely blow away any previous version of it
69 # (and we need not jump through hoops to try to delete
70 # it when configure exits.)
71 TMPDIR1="config-temp"
72 rm -rf "${TMPDIR1}"
73 if ! mkdir -p "${TMPDIR1}"; then
74 echo "ERROR: failed to create temporary directory"
75 exit 1
76 fi
77
78 TMPB="qemu-conf"
79 TMPC="${TMPDIR1}/${TMPB}.c"
80 TMPO="${TMPDIR1}/${TMPB}.o"
81 TMPE="${TMPDIR1}/${TMPB}.exe"
82
83 rm -f config.log
84
85 # Print a helpful header at the top of config.log
86 echo "# QEMU configure log $(date)" >> config.log
87 printf "# Configured with:" >> config.log
88 # repeat the invocation to log and stdout for CI
89 invoke=$(printf " '%s'" "$0" "$@")
90 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
91 { echo "$invoke"; echo; echo "#"; } >> config.log
92
93 quote_sh() {
94 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
95 }
96
97 print_error() {
98 (echo
99 echo "ERROR: $1"
100 while test -n "$2"; do
101 echo " $2"
102 shift
103 done
104 echo) >&2
105 }
106
107 error_exit() {
108 print_error "$@"
109 exit 1
110 }
111
112 do_compiler() {
113 # Run the compiler, capturing its output to the log. First argument
114 # is compiler binary to execute.
115 compiler="$1"
116 shift
117 if test -n "$BASH_VERSION"; then eval '
118 echo >>config.log "
119 funcs: ${FUNCNAME[*]}
120 lines: ${BASH_LINENO[*]}"
121 '; fi
122 echo $compiler "$@" >> config.log
123 $compiler "$@" >> config.log 2>&1 || return $?
124 }
125
126 do_cc() {
127 do_compiler "$cc" $CPU_CFLAGS "$@"
128 }
129
130 compile_object() {
131 local_cflags="$1"
132 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -c -o $TMPO $TMPC
133 }
134
135 compile_prog() {
136 local_cflags="$1"
137 local_ldflags="$2"
138 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -o $TMPE $TMPC \
139 $LDFLAGS $EXTRA_LDFLAGS $local_ldflags
140 }
141
142 # symbolically link $1 to $2. Portable version of "ln -sf".
143 symlink() {
144 rm -rf "$2"
145 mkdir -p "$(dirname "$2")"
146 ln -s "$1" "$2"
147 }
148
149 # check whether a command is available to this shell (may be either an
150 # executable or a builtin)
151 has() {
152 type "$1" >/dev/null 2>&1
153 }
154
155 version_ge () {
156 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
157 local_ver2=$(echo "$2" | tr . ' ')
158 while true; do
159 set x $local_ver1
160 local_first=${2-0}
161 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
162 shift ${2:+2}
163 local_ver1=$*
164 set x $local_ver2
165 # the second argument finished, the first must be greater or equal
166 test $# = 1 && return 0
167 test $local_first -lt $2 && return 1
168 test $local_first -gt $2 && return 0
169 shift ${2:+2}
170 local_ver2=$*
171 done
172 }
173
174 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
175 then
176 error_exit "main directory cannot contain spaces nor colons"
177 fi
178
179 # parse CC options first; some compiler tests are used to establish
180 # some defaults, based on the host environment
181
182 # default parameters
183 cpu=""
184 cross_compile="no"
185 cross_prefix=""
186 host_cc="cc"
187 EXTRA_CFLAGS=""
188 EXTRA_CXXFLAGS=""
189 EXTRA_OBJCFLAGS=""
190 EXTRA_LDFLAGS=""
191
192 # Default value for a variable defining feature "foo".
193 # * foo="no" feature will only be used if --enable-foo arg is given
194 # * foo="" feature will be searched for, and if found, will be used
195 # unless --disable-foo is given
196 # * foo="yes" this value will only be set by --enable-foo flag.
197 # feature will searched for,
198 # if not found, configure exits with error
199 #
200 # Always add --enable-foo and --disable-foo command line args.
201 # Distributions want to ensure that several features are compiled in, and it
202 # is impossible without a --enable-foo that exits if a feature is not found.
203 default_feature=""
204
205 for opt do
206 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
207 case "$opt" in
208 --cross-prefix=*) cross_prefix="$optarg"
209 cross_compile="yes"
210 ;;
211 --cc=*) CC="$optarg"
212 ;;
213 --cxx=*) CXX="$optarg"
214 ;;
215 --objcc=*) objcc="$optarg"
216 ;;
217 --cpu=*) cpu="$optarg"
218 ;;
219 --extra-cflags=*)
220 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
221 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
222 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
223 ;;
224 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
225 ;;
226 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
227 ;;
228 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
229 ;;
230 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
231 ;;
232 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
233 eval "cross_cc_cflags_${cc_arch}=\$optarg"
234 ;;
235 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
236 eval "cross_cc_${cc_arch}=\$optarg"
237 ;;
238 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
239 ;;
240 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
241 eval "cross_prefix_${cc_arch}=\$optarg"
242 ;;
243 --without-default-features) default_feature="no"
244 ;;
245 esac
246 done
247
248
249 if test -e "$source_path/.git"
250 then
251 git_submodules_action="update"
252 else
253 git_submodules_action="ignore"
254 fi
255
256 git_submodules="subprojects/keycodemapdb"
257 git="git"
258 debug_tcg="no"
259 docs="auto"
260 EXESUF=""
261 prefix="/usr/local"
262 qemu_suffix="qemu"
263 softmmu="yes"
264 linux_user=""
265 bsd_user=""
266 plugins="$default_feature"
267 ninja=""
268 python=
269 download="enabled"
270 bindir="bin"
271 skip_meson=no
272 vfio_user_server="disabled"
273 use_containers="yes"
274 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
275 gdb_arches=""
276 werror=""
277
278 # Don't accept a target_list environment variable.
279 unset target_list
280 unset target_list_exclude
281
282 # The following Meson options are handled manually (still they
283 # are included in the automatically generated help message)
284
285 # 1. Track which submodules are needed
286 fdt="auto"
287
288 # 2. Automatically enable/disable other options
289 tcg="auto"
290 cfi="false"
291
292 # 3. Need to check for -static-pie before Meson runs. Also,
293 # Meson has PIE as a boolean rather than enabled/disabled/auto.
294 pie=""
295 static="no"
296
297 # Preferred compiler:
298 # ${CC} (if set)
299 # ${cross_prefix}gcc (if cross-prefix specified)
300 # system compiler
301 if test -z "${CC}${cross_prefix}"; then
302 cc="$host_cc"
303 else
304 cc="${CC-${cross_prefix}gcc}"
305 fi
306
307 if test -z "${CXX}${cross_prefix}"; then
308 cxx="c++"
309 else
310 cxx="${CXX-${cross_prefix}g++}"
311 fi
312
313 # Preferred ObjC compiler:
314 # $objcc (if set, i.e. via --objcc option)
315 # ${cross_prefix}clang (if cross-prefix specified)
316 # clang (if available)
317 # $cc
318 if test -z "${objcc}${cross_prefix}"; then
319 if has clang; then
320 objcc=clang
321 else
322 objcc="$cc"
323 fi
324 else
325 objcc="${objcc-${cross_prefix}clang}"
326 fi
327
328 ar="${AR-${cross_prefix}ar}"
329 as="${AS-${cross_prefix}as}"
330 ccas="${CCAS-$cc}"
331 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
332 ld="${LD-${cross_prefix}ld}"
333 ranlib="${RANLIB-${cross_prefix}ranlib}"
334 nm="${NM-${cross_prefix}nm}"
335 smbd="$SMBD"
336 strip="${STRIP-${cross_prefix}strip}"
337 widl="${WIDL-${cross_prefix}widl}"
338 windres="${WINDRES-${cross_prefix}windres}"
339 windmc="${WINDMC-${cross_prefix}windmc}"
340 pkg_config="${PKG_CONFIG-${cross_prefix}pkg-config}"
341 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
342
343 check_define() {
344 cat > $TMPC <<EOF
345 #if !defined($1)
346 #error $1 not defined
347 #endif
348 int main(void) { return 0; }
349 EOF
350 compile_object
351 }
352
353 write_c_skeleton() {
354 cat > $TMPC <<EOF
355 int main(void) { return 0; }
356 EOF
357 }
358
359 if check_define __linux__ ; then
360 targetos=linux
361 elif check_define _WIN32 ; then
362 targetos=windows
363 elif check_define __OpenBSD__ ; then
364 targetos=openbsd
365 elif check_define __sun__ ; then
366 targetos=sunos
367 elif check_define __HAIKU__ ; then
368 targetos=haiku
369 elif check_define __FreeBSD__ ; then
370 targetos=freebsd
371 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
372 targetos=gnu/kfreebsd
373 elif check_define __DragonFly__ ; then
374 targetos=dragonfly
375 elif check_define __NetBSD__; then
376 targetos=netbsd
377 elif check_define __APPLE__; then
378 targetos=darwin
379 else
380 # This is a fatal error, but don't report it yet, because we
381 # might be going to just print the --help text, or it might
382 # be the result of a missing compiler.
383 targetos=bogus
384 fi
385
386 # OS specific
387
388 mingw32="no"
389 bsd="no"
390 linux="no"
391 solaris="no"
392 case $targetos in
393 windows)
394 mingw32="yes"
395 plugins="no"
396 pie="no"
397 ;;
398 gnu/kfreebsd)
399 bsd="yes"
400 ;;
401 freebsd)
402 bsd="yes"
403 # needed for kinfo_getvmmap(3) in libutil.h
404 ;;
405 dragonfly)
406 bsd="yes"
407 ;;
408 netbsd)
409 bsd="yes"
410 ;;
411 openbsd)
412 bsd="yes"
413 ;;
414 darwin)
415 bsd="yes"
416 darwin="yes"
417 ;;
418 sunos)
419 solaris="yes"
420 ;;
421 haiku)
422 pie="no"
423 ;;
424 linux)
425 linux="yes"
426 ;;
427 esac
428
429 if test ! -z "$cpu" ; then
430 # command line argument
431 :
432 elif check_define __i386__ ; then
433 cpu="i386"
434 elif check_define __x86_64__ ; then
435 if check_define __ILP32__ ; then
436 cpu="x32"
437 else
438 cpu="x86_64"
439 fi
440 elif check_define __sparc__ ; then
441 if check_define __arch64__ ; then
442 cpu="sparc64"
443 else
444 cpu="sparc"
445 fi
446 elif check_define _ARCH_PPC ; then
447 if check_define _ARCH_PPC64 ; then
448 if check_define _LITTLE_ENDIAN ; then
449 cpu="ppc64le"
450 else
451 cpu="ppc64"
452 fi
453 else
454 cpu="ppc"
455 fi
456 elif check_define __mips__ ; then
457 cpu="mips"
458 elif check_define __s390__ ; then
459 if check_define __s390x__ ; then
460 cpu="s390x"
461 else
462 cpu="s390"
463 fi
464 elif check_define __riscv ; then
465 cpu="riscv"
466 elif check_define __arm__ ; then
467 cpu="arm"
468 elif check_define __aarch64__ ; then
469 cpu="aarch64"
470 elif check_define __loongarch64 ; then
471 cpu="loongarch64"
472 else
473 # Using uname is really broken, but it is just a fallback for architectures
474 # that are going to use TCI anyway
475 cpu=$(uname -m)
476 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
477 fi
478
479 # Normalise host CPU name and set multilib cflags. The canonicalization
480 # isn't really necessary, because the architectures that we check for
481 # should not hit the 'uname -m' case, but better safe than sorry.
482 # Note that this case should only have supported host CPUs, not guests.
483 case "$cpu" in
484 armv*b|armv*l|arm)
485 cpu="arm" ;;
486
487 i386|i486|i586|i686)
488 cpu="i386"
489 CPU_CFLAGS="-m32" ;;
490 x32)
491 cpu="x86_64"
492 CPU_CFLAGS="-mx32" ;;
493 x86_64|amd64)
494 cpu="x86_64"
495 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
496 # If we truly care, we should simply detect this case at
497 # runtime and generate the fallback to serial emulation.
498 CPU_CFLAGS="-m64 -mcx16" ;;
499
500 mips*)
501 cpu="mips" ;;
502
503 ppc)
504 CPU_CFLAGS="-m32" ;;
505 ppc64)
506 CPU_CFLAGS="-m64 -mbig-endian" ;;
507 ppc64le)
508 cpu="ppc64"
509 CPU_CFLAGS="-m64 -mlittle-endian" ;;
510
511 s390)
512 CPU_CFLAGS="-m31" ;;
513 s390x)
514 CPU_CFLAGS="-m64" ;;
515
516 sparc|sun4[cdmuv])
517 cpu="sparc"
518 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
519 sparc64)
520 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
521 esac
522
523 check_py_version() {
524 # We require python >= 3.7.
525 # NB: a True python conditional creates a non-zero return code (Failure)
526 "$1" -c 'import sys; sys.exit(sys.version_info < (3,7))'
527 }
528
529 first_python=
530 if test -z "${PYTHON}"; then
531 # A bare 'python' is traditionally python 2.x, but some distros
532 # have it as python 3.x, so check in both places.
533 for binary in python3 python python3.11 python3.10 python3.9 python3.8 python3.7; do
534 if has "$binary"; then
535 python=$(command -v "$binary")
536 if check_py_version "$python"; then
537 # This one is good.
538 first_python=
539 break
540 else
541 first_python=$python
542 fi
543 fi
544 done
545 else
546 # Same as above, but only check the environment variable.
547 has "${PYTHON}" || error_exit "The PYTHON environment variable does not point to an executable"
548 python=$(command -v "$PYTHON")
549 if check_py_version "$python"; then
550 # This one is good.
551 first_python=
552 else
553 first_python=$first_python
554 fi
555 fi
556
557 # Check for ancillary tools used in testing
558 genisoimage=
559 for binary in genisoimage mkisofs
560 do
561 if has $binary
562 then
563 genisoimage=$(command -v "$binary")
564 break
565 fi
566 done
567
568 if test "$mingw32" = "yes" ; then
569 EXESUF=".exe"
570 prefix="/qemu"
571 bindir=""
572 qemu_suffix=""
573 fi
574
575 meson_option_build_array() {
576 printf '['
577 (if test "$targetos" = windows; then
578 IFS=\;
579 else
580 IFS=:
581 fi
582 for e in $1; do
583 printf '"""'
584 # backslash escape any '\' and '"' characters
585 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
586 printf '""",'
587 done)
588 printf ']\n'
589 }
590
591 . "$source_path/scripts/meson-buildoptions.sh"
592
593 meson_options=
594 meson_option_add() {
595 meson_options="$meson_options $(quote_sh "$1")"
596 }
597 meson_option_parse() {
598 meson_options="$meson_options $(_meson_option_parse "$@")"
599 if test $? -eq 1; then
600 echo "ERROR: unknown option $1"
601 echo "Try '$0 --help' for more information"
602 exit 1
603 fi
604 }
605
606 for opt do
607 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
608 case "$opt" in
609 --help|-h) show_help=yes
610 ;;
611 --version|-V) exec cat "$source_path/VERSION"
612 ;;
613 --prefix=*) prefix="$optarg"
614 ;;
615 --cross-prefix=*)
616 ;;
617 --cc=*)
618 ;;
619 --host-cc=*) host_cc="$optarg"
620 ;;
621 --cxx=*)
622 ;;
623 --objcc=*)
624 ;;
625 --make=*)
626 ;;
627 --install=*)
628 ;;
629 --python=*) python="$optarg"
630 ;;
631 --skip-meson) skip_meson=yes
632 ;;
633 --ninja=*) ninja="$optarg"
634 ;;
635 --smbd=*) smbd="$optarg"
636 ;;
637 --extra-cflags=*)
638 ;;
639 --extra-cxxflags=*)
640 ;;
641 --extra-objcflags=*)
642 ;;
643 --extra-ldflags=*)
644 ;;
645 --cross-cc-*)
646 ;;
647 --cross-prefix-*)
648 ;;
649 --enable-docs) docs=enabled
650 ;;
651 --disable-docs) docs=disabled
652 ;;
653 --cpu=*)
654 ;;
655 --target-list=*) target_list="$optarg"
656 if test "$target_list_exclude"; then
657 error_exit "Can't mix --target-list with --target-list-exclude"
658 fi
659 ;;
660 --target-list-exclude=*) target_list_exclude="$optarg"
661 if test "$target_list"; then
662 error_exit "Can't mix --target-list-exclude with --target-list"
663 fi
664 ;;
665 --with-default-devices) meson_option_add -Ddefault_devices=true
666 ;;
667 --without-default-devices) meson_option_add -Ddefault_devices=false
668 ;;
669 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
670 ;;
671 --with-devices-*) device_arch=${opt#--with-devices-};
672 device_arch=${device_arch%%=*}
673 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
674 if test -f "$cf"; then
675 device_archs="$device_archs $device_arch"
676 eval "devices_${device_arch}=\$optarg"
677 else
678 error_exit "File $cf does not exist"
679 fi
680 ;;
681 --without-default-features) # processed above
682 ;;
683 --static) static="yes"
684 ;;
685 --bindir=*) bindir="$optarg"
686 ;;
687 --with-suffix=*) qemu_suffix="$optarg"
688 ;;
689 --host=*|--build=*|\
690 --disable-dependency-tracking|\
691 --sbindir=*|--sharedstatedir=*|\
692 --oldincludedir=*|--datarootdir=*|--infodir=*|\
693 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
694 # These switches are silently ignored, for compatibility with
695 # autoconf-generated configure scripts. This allows QEMU's
696 # configure to be used by RPM and similar macros that set
697 # lots of directory switches by default.
698 ;;
699 --enable-debug-tcg) debug_tcg="yes"
700 ;;
701 --disable-debug-tcg) debug_tcg="no"
702 ;;
703 --enable-debug)
704 # Enable debugging options that aren't excessively noisy
705 debug_tcg="yes"
706 meson_option_parse --enable-debug-graph-lock ""
707 meson_option_parse --enable-debug-mutex ""
708 meson_option_add -Doptimization=0
709 ;;
710 --disable-tcg) tcg="disabled"
711 plugins="no"
712 ;;
713 --enable-tcg) tcg="enabled"
714 ;;
715 --disable-system) softmmu="no"
716 ;;
717 --enable-system) softmmu="yes"
718 ;;
719 --disable-user)
720 linux_user="no" ;
721 bsd_user="no" ;
722 ;;
723 --enable-user) ;;
724 --disable-linux-user) linux_user="no"
725 ;;
726 --enable-linux-user) linux_user="yes"
727 ;;
728 --disable-bsd-user) bsd_user="no"
729 ;;
730 --enable-bsd-user) bsd_user="yes"
731 ;;
732 --enable-pie) pie="yes"
733 ;;
734 --disable-pie) pie="no"
735 ;;
736 --enable-werror) werror="yes"
737 ;;
738 --disable-werror) werror="no"
739 ;;
740 --enable-cfi)
741 cfi="true";
742 meson_option_add -Db_lto=true
743 ;;
744 --disable-cfi) cfi="false"
745 ;;
746 --disable-fdt) fdt="disabled"
747 ;;
748 --enable-fdt) fdt="enabled"
749 ;;
750 --enable-fdt=git) fdt="internal"
751 ;;
752 --enable-fdt=*) fdt="$optarg"
753 ;;
754 --with-git-submodules=*)
755 git_submodules_action="$optarg"
756 ;;
757 --disable-download) download="disabled"
758 ;;
759 --enable-download) download="enabled"
760 ;;
761 --enable-plugins) if test "$mingw32" = "yes"; then
762 error_exit "TCG plugins not currently supported on Windows platforms"
763 else
764 plugins="yes"
765 fi
766 ;;
767 --disable-plugins) plugins="no"
768 ;;
769 --enable-containers) use_containers="yes"
770 ;;
771 --disable-containers) use_containers="no"
772 ;;
773 --gdb=*) gdb_bin="$optarg"
774 ;;
775 --enable-vfio-user-server) vfio_user_server="enabled"
776 ;;
777 --disable-vfio-user-server) vfio_user_server="disabled"
778 ;;
779 # everything else has the same name in configure and meson
780 --*) meson_option_parse "$opt" "$optarg"
781 ;;
782 esac
783 done
784
785 # test for any invalid configuration combinations
786 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
787 error_exit "Can't enable plugins on non-TCG builds"
788 fi
789
790 case $git_submodules_action in
791 update|validate)
792 if test ! -e "$source_path/.git" || ! has git; then
793 echo "ERROR: cannot $git_submodules_action git submodules without .git"
794 exit 1
795 fi
796 ;;
797 ignore)
798 if ! test -f "$source_path/subprojects/keycodemapdb/README"
799 then
800 echo
801 echo "ERROR: missing GIT submodules"
802 echo
803 if test -e "$source_path/.git"; then
804 echo "--with-git-submodules=ignore specified but submodules were not"
805 echo "checked out. Please initialize and update submodules."
806 else
807 echo "This is not a GIT checkout but module content appears to"
808 echo "be missing. Do not use 'git archive' or GitHub download links"
809 echo "to acquire QEMU source archives. Non-GIT builds are only"
810 echo "supported with source archives linked from:"
811 echo
812 echo " https://www.qemu.org/download/#source"
813 echo
814 echo "Developers working with GIT can use scripts/archive-source.sh"
815 echo "if they need to create valid source archives."
816 fi
817 echo
818 exit 1
819 fi
820 ;;
821 *)
822 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
823 exit 1
824 ;;
825 esac
826
827 default_target_list=""
828 mak_wilds=""
829
830 if [ "$linux_user" != no ]; then
831 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
832 linux_user=yes
833 elif [ "$linux_user" = yes ]; then
834 error_exit "linux-user not supported on this architecture"
835 fi
836 fi
837 if [ "$bsd_user" != no ]; then
838 if [ "$bsd_user" = "" ]; then
839 test $targetos = freebsd && bsd_user=yes
840 fi
841 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
842 error_exit "bsd-user not supported on this host OS"
843 fi
844 fi
845 if [ "$softmmu" = "yes" ]; then
846 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
847 fi
848 if [ "$linux_user" = "yes" ]; then
849 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
850 fi
851 if [ "$bsd_user" = "yes" ]; then
852 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
853 fi
854
855 for config in $mak_wilds; do
856 target="$(basename "$config" .mak)"
857 if echo "$target_list_exclude" | grep -vq "$target"; then
858 default_target_list="${default_target_list} $target"
859 fi
860 done
861
862 if test x"$show_help" = x"yes" ; then
863 cat << EOF
864
865 Usage: configure [options]
866 Options: [defaults in brackets after descriptions]
867
868 Standard options:
869 --help print this message
870 --prefix=PREFIX install in PREFIX [$prefix]
871 --target-list=LIST set target list (default: build all)
872 $(echo Available targets: $default_target_list | \
873 fold -s -w 53 | sed -e 's/^/ /')
874 --target-list-exclude=LIST exclude a set of targets from the default target-list
875
876 Advanced options (experts only):
877 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
878 --cc=CC use C compiler CC [$cc]
879 --host-cc=CC use C compiler CC [$host_cc] for code run at
880 build time
881 --cxx=CXX use C++ compiler CXX [$cxx]
882 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
883 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
884 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
885 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
886 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
887 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
888 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
889 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
890 --python=PYTHON use specified python [$python]
891 --ninja=NINJA use specified ninja [$ninja]
892 --smbd=SMBD use specified smbd [$smbd]
893 --with-git-submodules=update update git submodules (default if .git dir exists)
894 --with-git-submodules=validate fail if git submodules are not up to date
895 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
896 --static enable static build [$static]
897 --bindir=PATH install binaries in PATH
898 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
899 --without-default-features default all --enable-* options to "disabled"
900 --without-default-devices do not include any device that is not needed to
901 start the emulator (only use if you are including
902 desired devices in configs/devices/)
903 --with-devices-ARCH=NAME override default configs/devices
904 --enable-debug enable common debug build options
905 --disable-werror disable compilation abort on warning
906 --cpu=CPU Build for host CPU [$cpu]
907 --enable-plugins
908 enable plugins via shared library loading
909 --disable-containers don't use containers for cross-building
910 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
911 EOF
912 meson_options_help
913 cat << EOF
914 system all system emulation targets
915 user supported user emulation targets
916 linux-user all linux usermode emulation targets
917 bsd-user all BSD usermode emulation targets
918 pie Position Independent Executables
919 debug-tcg TCG debugging (default is disabled)
920
921 NOTE: The object files are built at the place where configure is launched
922 EOF
923 exit 0
924 fi
925
926 # Remove old dependency files to make sure that they get properly regenerated
927 rm -f ./*/config-devices.mak.d
928
929 if test -z "$python"
930 then
931 # If first_python is set, there was a binary somewhere even though
932 # it was not suitable. Use it for the error message.
933 if test -n "$first_python"; then
934 error_exit "Cannot use '$first_python', Python >= 3.7 is required." \
935 "Use --python=/path/to/python to specify a supported Python."
936 else
937 error_exit "Python not found. Use --python=/path/to/python"
938 fi
939 fi
940
941 if ! check_py_version "$python"; then
942 error_exit "Cannot use '$python', Python >= 3.7 is required." \
943 "Use --python=/path/to/python to specify a supported Python." \
944 "Maybe try:" \
945 " openSUSE Leap 15.3+: zypper install python39" \
946 " CentOS 8: dnf install python38"
947 fi
948
949 # Resolve PATH
950 python="$(command -v "$python")"
951
952 # Create a Python virtual environment using our configured python.
953 # The stdout of this script will be the location of a symlink that
954 # points to the configured Python.
955 # Entry point scripts for pip, meson, and sphinx are generated if those
956 # packages are present.
957
958 # Defaults assumed for now:
959 # - venv is cleared if it exists already;
960 # - venv is allowed to use system packages;
961 # - all setup can be performed offline;
962 # - missing packages may be fetched from PyPI,
963 # unless --disable-download is passed.
964 # - pip is not installed into the venv when possible,
965 # but ensurepip is called as a fallback when necessary.
966
967 echo "python determined to be '$python'"
968 echo "python version: $($python --version)"
969
970 python="$($python -B "${source_path}/python/scripts/mkvenv.py" create pyvenv)"
971 if test "$?" -ne 0 ; then
972 error_exit "python venv creation failed"
973 fi
974
975 # Suppress writing compiled files
976 python="$python -B"
977 mkvenv="$python ${source_path}/python/scripts/mkvenv.py"
978
979 mkvenv_flags=""
980 if test "$download" = "enabled" ; then
981 mkvenv_flags="--online"
982 fi
983
984 if ! $mkvenv ensure \
985 $mkvenv_flags \
986 --dir "${source_path}/python/wheels" \
987 --diagnose "meson" \
988 "meson>=0.63.0" ;
989 then
990 exit 1
991 fi
992
993 # At this point, we expect Meson to be installed and available.
994 # We expect mkvenv or pip to have created pyvenv/bin/meson for us.
995 # We ignore PATH completely here: we want to use the venv's Meson
996 # *exclusively*.
997
998 meson="$(cd pyvenv/bin; pwd)/meson"
999
1000 # Conditionally ensure Sphinx is installed.
1001
1002 mkvenv_flags=""
1003 if test "$download" = "enabled" -a "$docs" = "enabled" ; then
1004 mkvenv_flags="--online"
1005 fi
1006
1007 if test "$docs" != "disabled" ; then
1008 if ! $mkvenv ensure \
1009 $mkvenv_flags \
1010 --diagnose "sphinx-build" \
1011 "sphinx>=1.6.0" "sphinx-rtd-theme>=0.5.0";
1012 then
1013 if test "$docs" = "enabled" ; then
1014 exit 1
1015 fi
1016 echo "Sphinx not found/usable, disabling docs."
1017 docs=disabled
1018 else
1019 docs=enabled
1020 fi
1021 fi
1022
1023 # Probe for ninja
1024
1025 if test -z "$ninja"; then
1026 for c in ninja ninja-build samu; do
1027 if has $c; then
1028 ninja=$(command -v "$c")
1029 break
1030 fi
1031 done
1032 if test -z "$ninja"; then
1033 error_exit "Cannot find Ninja"
1034 fi
1035 fi
1036
1037 # Consult white-list to determine whether to enable werror
1038 # by default. Only enable by default for git builds
1039 if test -z "$werror" ; then
1040 if test "$git_submodules_action" != "ignore" && \
1041 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1042 werror="yes"
1043 else
1044 werror="no"
1045 fi
1046 fi
1047
1048 if test "$targetos" = "bogus"; then
1049 # Now that we know that we're not printing the help and that
1050 # the compiler works (so the results of the check_defines we used
1051 # to identify the OS are reliable), if we didn't recognize the
1052 # host OS we should stop now.
1053 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1054 fi
1055
1056 if test "$static" = "yes" ; then
1057 if test "$plugins" = "yes"; then
1058 error_exit "static and plugins are mutually incompatible"
1059 else
1060 plugins="no"
1061 fi
1062 fi
1063 test "$plugins" = "" && plugins=yes
1064
1065 cat > $TMPC << EOF
1066
1067 #ifdef __linux__
1068 # define THREAD __thread
1069 #else
1070 # define THREAD
1071 #endif
1072 static THREAD int tls_var;
1073 int main(void) { return tls_var; }
1074 EOF
1075
1076 if test "$static" = "yes"; then
1077 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1078 pie="yes"
1079 elif test "$pie" = "yes"; then
1080 error_exit "-static-pie not available due to missing toolchain support"
1081 else
1082 pie="no"
1083 fi
1084 elif test "$pie" != "no"; then
1085 if compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1086 pie="yes"
1087 elif test "$pie" = "yes"; then
1088 error_exit "PIE not available due to missing toolchain support"
1089 else
1090 echo "Disabling PIE due to missing toolchain support"
1091 pie="no"
1092 fi
1093 fi
1094
1095 ##########################################
1096
1097 if test -z "${target_list+xxx}" ; then
1098 default_targets=yes
1099 for target in $default_target_list; do
1100 target_list="$target_list $target"
1101 done
1102 target_list="${target_list# }"
1103 else
1104 default_targets=no
1105 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1106 for target in $target_list; do
1107 # Check that we recognised the target name; this allows a more
1108 # friendly error message than if we let it fall through.
1109 case " $default_target_list " in
1110 *" $target "*)
1111 ;;
1112 *)
1113 error_exit "Unknown target name '$target'"
1114 ;;
1115 esac
1116 done
1117 fi
1118
1119 # see if system emulation was really requested
1120 case " $target_list " in
1121 *"-softmmu "*) softmmu=yes
1122 ;;
1123 *) softmmu=no
1124 ;;
1125 esac
1126
1127 if test "$tcg" = "auto"; then
1128 if test -z "$target_list"; then
1129 tcg="disabled"
1130 else
1131 tcg="enabled"
1132 fi
1133 fi
1134
1135 if test "$tcg" = "enabled"; then
1136 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1137 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1138 fi
1139
1140 ##########################################
1141 # big/little endian test
1142 cat > $TMPC << EOF
1143 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1144 # error LITTLE
1145 #endif
1146 int main(void) { return 0; }
1147 EOF
1148
1149 if ! compile_prog ; then
1150 bigendian="no"
1151 else
1152 cat > $TMPC << EOF
1153 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1154 # error BIG
1155 #endif
1156 int main(void) { return 0; }
1157 EOF
1158
1159 if ! compile_prog ; then
1160 bigendian="yes"
1161 else
1162 echo big/little test failed
1163 exit 1
1164 fi
1165 fi
1166
1167 ##########################################
1168 # fdt probe
1169
1170 case "$fdt" in
1171 auto | enabled | internal)
1172 # Simpler to always update submodule, even if not needed.
1173 git_submodules="${git_submodules} subprojects/dtc"
1174 ;;
1175 esac
1176
1177 ########################################
1178 # check if ccache is interfering with
1179 # semantic analysis of macros
1180
1181 unset CCACHE_CPP2
1182 ccache_cpp2=no
1183 cat > $TMPC << EOF
1184 static const int Z = 1;
1185 #define fn() ({ Z; })
1186 #define TAUT(X) ((X) == Z)
1187 #define PAREN(X, Y) (X == Y)
1188 #define ID(X) (X)
1189 int main(void)
1190 {
1191 int x = 0, y = 0;
1192 x = ID(x);
1193 x = fn();
1194 fn();
1195 if (PAREN(x, y)) return 0;
1196 if (TAUT(Z)) return 0;
1197 return 0;
1198 }
1199 EOF
1200
1201 if ! compile_object "-Werror"; then
1202 ccache_cpp2=yes
1203 fi
1204
1205 ##########################################
1206 # functions to probe cross compilers
1207
1208 container="no"
1209 runc=""
1210 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1211 case $($python "$source_path"/tests/docker/docker.py probe) in
1212 *docker) container=docker ;;
1213 podman) container=podman ;;
1214 no) container=no ;;
1215 esac
1216 if test "$container" != "no"; then
1217 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1218 runc=$($python "$source_path"/tests/docker/docker.py probe)
1219 fi
1220 fi
1221
1222 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1223 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1224 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1225 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1226 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1227 : ${cross_prefix_armeb="$cross_prefix_arm"}
1228 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1229 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1230 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1231 : ${cross_prefix_i386="i686-linux-gnu-"}
1232 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1233 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1234 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1235 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1236 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1237 : ${cross_prefix_mips="mips-linux-gnu-"}
1238 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1239 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1240 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1241 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1242 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1243 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1244 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1245 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1246 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1247 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1248
1249 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1250 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1251 : ${cross_cc_armeb="$cross_cc_arm"}
1252 : ${cross_cc_cflags_armeb="-mbig-endian"}
1253 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1254 : ${cross_cc_cflags_hexagon="-mv73 -O2 -static"}
1255 : ${cross_cc_cflags_i386="-m32"}
1256 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1257 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1258 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1259 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1260 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1261 : ${cross_cc_sparc="$cross_cc_sparc64"}
1262 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1263 : ${cross_cc_cflags_x86_64="-m64"}
1264
1265 compute_target_variable() {
1266 eval "$2="
1267 if eval test -n "\"\${cross_prefix_$1}\""; then
1268 if eval has "\"\${cross_prefix_$1}\$3\""; then
1269 eval "$2=\"\${cross_prefix_$1}\$3\""
1270 fi
1271 fi
1272 }
1273
1274 have_target() {
1275 for i; do
1276 case " $target_list " in
1277 *" $i "*) return 0;;
1278 *) ;;
1279 esac
1280 done
1281 return 1
1282 }
1283
1284 # probe_target_compiler TARGET
1285 #
1286 # Look for a compiler for the given target, either native or cross.
1287 # Set variables target_* if a compiler is found, and container_cross_*
1288 # if a Docker-based cross-compiler image is known for the target.
1289 # Set got_cross_cc to yes/no depending on whether a non-container-based
1290 # compiler was found.
1291 #
1292 # If TARGET is a user-mode emulation target, also set build_static to
1293 # "y" if static linking is possible.
1294 #
1295 probe_target_compiler() {
1296 # reset all output variables
1297 got_cross_cc=no
1298 container_image=
1299 container_hosts=
1300 container_cross_cc=
1301 container_cross_ar=
1302 container_cross_as=
1303 container_cross_ld=
1304 container_cross_nm=
1305 container_cross_objcopy=
1306 container_cross_ranlib=
1307 container_cross_strip=
1308
1309 target_arch=${1%%-*}
1310 case $target_arch in
1311 aarch64) container_hosts="x86_64 aarch64" ;;
1312 alpha) container_hosts=x86_64 ;;
1313 arm) container_hosts="x86_64 aarch64" ;;
1314 cris) container_hosts=x86_64 ;;
1315 hexagon) container_hosts=x86_64 ;;
1316 hppa) container_hosts=x86_64 ;;
1317 i386) container_hosts=x86_64 ;;
1318 loongarch64) container_hosts=x86_64 ;;
1319 m68k) container_hosts=x86_64 ;;
1320 microblaze) container_hosts=x86_64 ;;
1321 mips64el) container_hosts=x86_64 ;;
1322 mips64) container_hosts=x86_64 ;;
1323 mipsel) container_hosts=x86_64 ;;
1324 mips) container_hosts=x86_64 ;;
1325 nios2) container_hosts=x86_64 ;;
1326 ppc) container_hosts=x86_64 ;;
1327 ppc64|ppc64le) container_hosts=x86_64 ;;
1328 riscv64) container_hosts=x86_64 ;;
1329 s390x) container_hosts=x86_64 ;;
1330 sh4) container_hosts=x86_64 ;;
1331 sparc64) container_hosts=x86_64 ;;
1332 tricore) container_hosts=x86_64 ;;
1333 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1334 xtensa*) container_hosts=x86_64 ;;
1335 esac
1336
1337 for host in $container_hosts; do
1338 test "$container" != no || continue
1339 test "$host" = "$cpu" || continue
1340 case $target_arch in
1341 aarch64)
1342 # We don't have any bigendian build tools so we only use this for AArch64
1343 container_image=debian-arm64-cross
1344 container_cross_prefix=aarch64-linux-gnu-
1345 container_cross_cc=${container_cross_prefix}gcc-10
1346 ;;
1347 alpha)
1348 container_image=debian-alpha-cross
1349 container_cross_prefix=alpha-linux-gnu-
1350 ;;
1351 arm)
1352 # We don't have any bigendian build tools so we only use this for ARM
1353 container_image=debian-armhf-cross
1354 container_cross_prefix=arm-linux-gnueabihf-
1355 ;;
1356 cris)
1357 container_image=fedora-cris-cross
1358 container_cross_prefix=cris-linux-gnu-
1359 ;;
1360 hexagon)
1361 container_image=debian-hexagon-cross
1362 container_cross_prefix=hexagon-unknown-linux-musl-
1363 container_cross_cc=${container_cross_prefix}clang
1364 ;;
1365 hppa)
1366 container_image=debian-hppa-cross
1367 container_cross_prefix=hppa-linux-gnu-
1368 ;;
1369 i386)
1370 container_image=fedora-i386-cross
1371 container_cross_prefix=
1372 ;;
1373 loongarch64)
1374 container_image=debian-loongarch-cross
1375 container_cross_prefix=loongarch64-unknown-linux-gnu-
1376 ;;
1377 m68k)
1378 container_image=debian-m68k-cross
1379 container_cross_prefix=m68k-linux-gnu-
1380 ;;
1381 microblaze)
1382 container_image=debian-microblaze-cross
1383 container_cross_prefix=microblaze-linux-musl-
1384 ;;
1385 mips64el)
1386 container_image=debian-mips64el-cross
1387 container_cross_prefix=mips64el-linux-gnuabi64-
1388 ;;
1389 mips64)
1390 container_image=debian-mips64-cross
1391 container_cross_prefix=mips64-linux-gnuabi64-
1392 ;;
1393 mipsel)
1394 container_image=debian-mipsel-cross
1395 container_cross_prefix=mipsel-linux-gnu-
1396 ;;
1397 mips)
1398 container_image=debian-mips-cross
1399 container_cross_prefix=mips-linux-gnu-
1400 ;;
1401 nios2)
1402 container_image=debian-nios2-cross
1403 container_cross_prefix=nios2-linux-gnu-
1404 ;;
1405 ppc)
1406 container_image=debian-powerpc-test-cross
1407 container_cross_prefix=powerpc-linux-gnu-
1408 container_cross_cc=${container_cross_prefix}gcc-10
1409 ;;
1410 ppc64|ppc64le)
1411 container_image=debian-powerpc-test-cross
1412 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
1413 container_cross_cc=${container_cross_prefix}gcc-10
1414 ;;
1415 riscv64)
1416 container_image=debian-riscv64-test-cross
1417 container_cross_prefix=riscv64-linux-gnu-
1418 ;;
1419 s390x)
1420 container_image=debian-s390x-cross
1421 container_cross_prefix=s390x-linux-gnu-
1422 ;;
1423 sh4)
1424 container_image=debian-sh4-cross
1425 container_cross_prefix=sh4-linux-gnu-
1426 ;;
1427 sparc64)
1428 container_image=debian-sparc64-cross
1429 container_cross_prefix=sparc64-linux-gnu-
1430 ;;
1431 tricore)
1432 container_image=debian-tricore-cross
1433 container_cross_prefix=tricore-
1434 container_cross_as=tricore-as
1435 container_cross_ld=tricore-ld
1436 break
1437 ;;
1438 x86_64)
1439 container_image=debian-amd64-cross
1440 container_cross_prefix=x86_64-linux-gnu-
1441 ;;
1442 xtensa*)
1443 container_hosts=x86_64
1444 container_image=debian-xtensa-cross
1445
1446 # default to the dc232b cpu
1447 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
1448 ;;
1449 esac
1450 : ${container_cross_cc:=${container_cross_prefix}gcc}
1451 : ${container_cross_ar:=${container_cross_prefix}ar}
1452 : ${container_cross_as:=${container_cross_prefix}as}
1453 : ${container_cross_ld:=${container_cross_prefix}ld}
1454 : ${container_cross_nm:=${container_cross_prefix}nm}
1455 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
1456 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
1457 : ${container_cross_strip:=${container_cross_prefix}strip}
1458 done
1459
1460 try=cross
1461 case "$target_arch:$cpu" in
1462 aarch64_be:aarch64 | \
1463 armeb:arm | \
1464 i386:x86_64 | \
1465 mips*:mips64 | \
1466 ppc*:ppc64 | \
1467 sparc:sparc64 | \
1468 "$cpu:$cpu")
1469 try='native cross' ;;
1470 esac
1471 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
1472 for thistry in $try; do
1473 case $thistry in
1474 native)
1475 target_cc=$cc
1476 target_ccas=$ccas
1477 target_ar=$ar
1478 target_as=$as
1479 target_ld=$ld
1480 target_nm=$nm
1481 target_objcopy=$objcopy
1482 target_ranlib=$ranlib
1483 target_strip=$strip
1484 ;;
1485 cross)
1486 target_cc=
1487 if eval test -n "\"\${cross_cc_$target_arch}\""; then
1488 if eval has "\"\${cross_cc_$target_arch}\""; then
1489 eval "target_cc=\"\${cross_cc_$target_arch}\""
1490 fi
1491 else
1492 compute_target_variable $target_arch target_cc gcc
1493 fi
1494 target_ccas=$target_cc
1495 compute_target_variable $target_arch target_ar ar
1496 compute_target_variable $target_arch target_as as
1497 compute_target_variable $target_arch target_ld ld
1498 compute_target_variable $target_arch target_nm nm
1499 compute_target_variable $target_arch target_objcopy objcopy
1500 compute_target_variable $target_arch target_ranlib ranlib
1501 compute_target_variable $target_arch target_strip strip
1502 ;;
1503 esac
1504
1505 if test -n "$target_cc"; then
1506 case $target_arch in
1507 i386|x86_64)
1508 if $target_cc --version | grep -qi "clang"; then
1509 continue
1510 fi
1511 ;;
1512 esac
1513 elif test -n "$target_as" && test -n "$target_ld"; then
1514 # Special handling for assembler only targets
1515 case $target in
1516 tricore-softmmu)
1517 build_static=
1518 got_cross_cc=yes
1519 break
1520 ;;
1521 *)
1522 continue
1523 ;;
1524 esac
1525 else
1526 continue
1527 fi
1528
1529 write_c_skeleton
1530 case $1 in
1531 *-softmmu)
1532 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
1533 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
1534 got_cross_cc=yes
1535 break
1536 fi
1537 ;;
1538 *)
1539 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
1540 build_static=y
1541 got_cross_cc=yes
1542 break
1543 fi
1544 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
1545 build_static=
1546 got_cross_cc=yes
1547 break
1548 fi
1549 ;;
1550 esac
1551 done
1552 if test $got_cross_cc != yes; then
1553 build_static=
1554 target_cc=
1555 target_ccas=
1556 target_ar=
1557 target_as=
1558 target_ld=
1559 target_nm=
1560 target_objcopy=
1561 target_ranlib=
1562 target_strip=
1563 fi
1564 test -n "$target_cc"
1565 }
1566
1567 write_target_makefile() {
1568 echo "EXTRA_CFLAGS=$target_cflags"
1569 if test -z "$target_cc" && test -z "$target_as"; then
1570 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
1571 echo "$1: docker-image-$container_image" >> Makefile.prereqs
1572 if test -n "$container_cross_cc"; then
1573 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1574 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1575 fi
1576 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
1577 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
1578 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
1579 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
1580 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
1581 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
1582 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
1583 else
1584 if test -n "$target_cc"; then
1585 echo "CC=$target_cc"
1586 echo "CCAS=$target_ccas"
1587 fi
1588 if test -n "$target_ar"; then
1589 echo "AR=$target_ar"
1590 fi
1591 if test -n "$target_as"; then
1592 echo "AS=$target_as"
1593 fi
1594 if test -n "$target_ld"; then
1595 echo "LD=$target_ld"
1596 fi
1597 if test -n "$target_nm"; then
1598 echo "NM=$target_nm"
1599 fi
1600 if test -n "$target_objcopy"; then
1601 echo "OBJCOPY=$target_objcopy"
1602 fi
1603 if test -n "$target_ranlib"; then
1604 echo "RANLIB=$target_ranlib"
1605 fi
1606 if test -n "$target_strip"; then
1607 echo "STRIP=$target_strip"
1608 fi
1609 fi
1610 }
1611
1612 ##########################################
1613 # check for vfio_user_server
1614
1615 case "$vfio_user_server" in
1616 enabled )
1617 if test "$git_submodules_action" != "ignore"; then
1618 git_submodules="${git_submodules} subprojects/libvfio-user"
1619 fi
1620 ;;
1621 esac
1622
1623 #######################################
1624 # cross-compiled firmware targets
1625
1626 # Set up build tree symlinks that point back into the source tree
1627 # (these can be both files and directories).
1628 # Caution: avoid adding files or directories here using wildcards. This
1629 # will result in problems later if a new file matching the wildcard is
1630 # added to the source tree -- nothing will cause configure to be rerun
1631 # so the build tree will be missing the link back to the new file, and
1632 # tests might fail. Prefer to keep the relevant files in their own
1633 # directory and symlink the directory instead.
1634 LINKS="Makefile"
1635 LINKS="$LINKS docs/config"
1636 LINKS="$LINKS pc-bios/optionrom/Makefile"
1637 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
1638 LINKS="$LINKS pc-bios/vof/Makefile"
1639 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
1640 LINKS="$LINKS tests/avocado tests/data"
1641 LINKS="$LINKS tests/qemu-iotests/check"
1642 LINKS="$LINKS python"
1643 LINKS="$LINKS contrib/plugins/Makefile "
1644 for f in $LINKS ; do
1645 if [ -e "$source_path/$f" ]; then
1646 symlink "$source_path/$f" "$f"
1647 fi
1648 done
1649
1650 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
1651
1652 # Mac OS X ships with a broken assembler
1653 roms=
1654 if have_target i386-softmmu x86_64-softmmu && \
1655 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
1656 test "$targetos" != "haiku" && \
1657 probe_target_compiler i386-softmmu; then
1658 roms="pc-bios/optionrom"
1659 config_mak=pc-bios/optionrom/config.mak
1660 echo "# Automatically generated by configure - do not modify" > $config_mak
1661 echo "TOPSRC_DIR=$source_path" >> $config_mak
1662 write_target_makefile >> $config_mak
1663 fi
1664
1665 if have_target ppc-softmmu ppc64-softmmu && \
1666 probe_target_compiler ppc-softmmu; then
1667 roms="$roms pc-bios/vof"
1668 config_mak=pc-bios/vof/config.mak
1669 echo "# Automatically generated by configure - do not modify" > $config_mak
1670 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
1671 write_target_makefile >> $config_mak
1672 fi
1673
1674 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
1675 # (which is the lowest architecture level that Clang supports)
1676 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
1677 write_c_skeleton
1678 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
1679 has_z900=$?
1680 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
1681 if [ $has_z900 != 0 ]; then
1682 echo "WARNING: Your compiler does not support the z900!"
1683 echo " The s390-ccw bios will only work with guest CPUs >= z10."
1684 fi
1685 roms="$roms pc-bios/s390-ccw"
1686 config_mak=pc-bios/s390-ccw/config-host.mak
1687 echo "# Automatically generated by configure - do not modify" > $config_mak
1688 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
1689 write_target_makefile >> $config_mak
1690 # SLOF is required for building the s390-ccw firmware on s390x,
1691 # since it is using the libnet code from SLOF for network booting.
1692 git_submodules="${git_submodules} roms/SLOF"
1693 fi
1694 fi
1695
1696 #######################################
1697 # generate config-host.mak
1698
1699 if ! (GIT=git "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
1700 exit 1
1701 fi
1702
1703 config_host_mak="config-host.mak"
1704
1705 echo "# Automatically generated by configure - do not modify" > $config_host_mak
1706 echo >> $config_host_mak
1707
1708 echo all: >> $config_host_mak
1709 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
1710 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
1711
1712 if test "$debug_tcg" = "yes" ; then
1713 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
1714 fi
1715 if test "$mingw32" = "yes" ; then
1716 echo "CONFIG_WIN32=y" >> $config_host_mak
1717 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER-QEMU}" >> $config_host_mak
1718 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO-Linux}" >> $config_host_mak
1719 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION-$(cat "$source_path"/VERSION)}" >> $config_host_mak
1720 else
1721 echo "CONFIG_POSIX=y" >> $config_host_mak
1722 fi
1723
1724 if test "$linux" = "yes" ; then
1725 echo "CONFIG_LINUX=y" >> $config_host_mak
1726 fi
1727
1728 if test "$darwin" = "yes" ; then
1729 echo "CONFIG_DARWIN=y" >> $config_host_mak
1730 fi
1731
1732 if test "$solaris" = "yes" ; then
1733 echo "CONFIG_SOLARIS=y" >> $config_host_mak
1734 fi
1735 echo "SRC_PATH=$source_path" >> $config_host_mak
1736 echo "TARGET_DIRS=$target_list" >> $config_host_mak
1737
1738 # XXX: suppress that
1739 if [ "$bsd" = "yes" ] ; then
1740 echo "CONFIG_BSD=y" >> $config_host_mak
1741 fi
1742
1743 if test "$plugins" = "yes" ; then
1744 echo "CONFIG_PLUGIN=y" >> $config_host_mak
1745 fi
1746
1747 if test -n "$gdb_bin"; then
1748 gdb_version=$($gdb_bin --version | head -n 1)
1749 if version_ge ${gdb_version##* } 9.1; then
1750 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
1751 gdb_arches=$($python "$source_path/scripts/probe-gdb-support.py" $gdb_bin)
1752 else
1753 gdb_bin=""
1754 fi
1755 fi
1756
1757 if test "$container" != no; then
1758 echo "ENGINE=$container" >> $config_host_mak
1759 echo "RUNC=$runc" >> $config_host_mak
1760 fi
1761 echo "ROMS=$roms" >> $config_host_mak
1762 echo "PYTHON=$python" >> $config_host_mak
1763 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
1764 echo "MESON=$meson" >> $config_host_mak
1765 echo "NINJA=$ninja" >> $config_host_mak
1766 echo "PKG_CONFIG=${pkg_config}" >> $config_host_mak
1767 echo "CC=$cc" >> $config_host_mak
1768 echo "EXESUF=$EXESUF" >> $config_host_mak
1769
1770 # use included Linux headers
1771 if test "$linux" = "yes" ; then
1772 mkdir -p linux-headers
1773 case "$cpu" in
1774 i386|x86_64)
1775 linux_arch=x86
1776 ;;
1777 ppc|ppc64)
1778 linux_arch=powerpc
1779 ;;
1780 s390x)
1781 linux_arch=s390
1782 ;;
1783 aarch64)
1784 linux_arch=arm64
1785 ;;
1786 loongarch*)
1787 linux_arch=loongarch
1788 ;;
1789 mips64)
1790 linux_arch=mips
1791 ;;
1792 *)
1793 # For most CPUs the kernel architecture name and QEMU CPU name match.
1794 linux_arch="$cpu"
1795 ;;
1796 esac
1797 # For non-KVM architectures we will not have asm headers
1798 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
1799 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
1800 fi
1801 fi
1802
1803 for target in $target_list; do
1804 target_dir="$target"
1805 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
1806 mkdir -p "$target_dir"
1807 case $target in
1808 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
1809 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
1810 esac
1811 done
1812
1813 if test "$default_targets" = "yes"; then
1814 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
1815 fi
1816
1817 if test "$ccache_cpp2" = "yes"; then
1818 echo "export CCACHE_CPP2=y" >> $config_host_mak
1819 fi
1820
1821 # tests/tcg configuration
1822 (config_host_mak=tests/tcg/config-host.mak
1823 mkdir -p tests/tcg
1824 echo "# Automatically generated by configure - do not modify" > $config_host_mak
1825 echo "SRC_PATH=$source_path" >> $config_host_mak
1826 echo "HOST_CC=$host_cc" >> $config_host_mak
1827
1828 # versioned checked in the main config_host.mak above
1829 if test -n "$gdb_bin"; then
1830 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
1831 fi
1832 if test "$plugins" = "yes" ; then
1833 echo "CONFIG_PLUGIN=y" >> $config_host_mak
1834 fi
1835
1836 tcg_tests_targets=
1837 for target in $target_list; do
1838 arch=${target%%-*}
1839
1840 case $target in
1841 xtensa*-linux-user)
1842 # the toolchain is not complete with headers, only build softmmu tests
1843 continue
1844 ;;
1845 *-softmmu)
1846 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
1847 qemu="qemu-system-$arch"
1848 ;;
1849 *-linux-user|*-bsd-user)
1850 qemu="qemu-$arch"
1851 ;;
1852 esac
1853
1854 if probe_target_compiler $target || test -n "$container_image"; then
1855 test -n "$container_image" && build_static=y
1856 mkdir -p "tests/tcg/$target"
1857 config_target_mak=tests/tcg/$target/config-target.mak
1858 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
1859 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
1860 echo "TARGET_NAME=$arch" >> "$config_target_mak"
1861 echo "TARGET=$target" >> "$config_target_mak"
1862 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
1863 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
1864 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
1865
1866 # will GDB work with these binaries?
1867 if test "${gdb_arches#*$arch}" != "$gdb_arches"; then
1868 echo "HOST_GDB_SUPPORTS_ARCH=y" >> "$config_target_mak"
1869 fi
1870
1871 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
1872 tcg_tests_targets="$tcg_tests_targets $target"
1873 fi
1874 done
1875
1876 if test "$tcg" = "enabled"; then
1877 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak
1878 fi
1879 )
1880
1881 if test "$skip_meson" = no; then
1882 cross="config-meson.cross.new"
1883 meson_quote() {
1884 test $# = 0 && return
1885 echo "'$(echo $* | sed "s/ /','/g")'"
1886 }
1887
1888 echo "# Automatically generated by configure - do not modify" > $cross
1889 echo "[properties]" >> $cross
1890
1891 # unroll any custom device configs
1892 for a in $device_archs; do
1893 eval "c=\$devices_${a}"
1894 echo "${a}-softmmu = '$c'" >> $cross
1895 done
1896
1897 echo "[built-in options]" >> $cross
1898 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
1899 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
1900 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
1901 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
1902 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
1903 echo "[binaries]" >> $cross
1904 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
1905 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
1906 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
1907 echo "ar = [$(meson_quote $ar)]" >> $cross
1908 echo "nm = [$(meson_quote $nm)]" >> $cross
1909 echo "pkgconfig = [$(meson_quote $pkg_config)]" >> $cross
1910 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
1911 if has $sdl2_config; then
1912 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
1913 fi
1914 echo "strip = [$(meson_quote $strip)]" >> $cross
1915 echo "widl = [$(meson_quote $widl)]" >> $cross
1916 echo "windres = [$(meson_quote $windres)]" >> $cross
1917 echo "windmc = [$(meson_quote $windmc)]" >> $cross
1918 if test "$cross_compile" = "yes"; then
1919 cross_arg="--cross-file config-meson.cross"
1920 echo "[host_machine]" >> $cross
1921 echo "system = '$targetos'" >> $cross
1922 case "$cpu" in
1923 i386)
1924 echo "cpu_family = 'x86'" >> $cross
1925 ;;
1926 *)
1927 echo "cpu_family = '$cpu'" >> $cross
1928 ;;
1929 esac
1930 echo "cpu = '$cpu'" >> $cross
1931 if test "$bigendian" = "yes" ; then
1932 echo "endian = 'big'" >> $cross
1933 else
1934 echo "endian = 'little'" >> $cross
1935 fi
1936 else
1937 cross_arg="--native-file config-meson.cross"
1938 fi
1939 mv $cross config-meson.cross
1940
1941 rm -rf meson-private meson-info meson-logs
1942
1943 # Built-in options
1944 test "$download" = "disabled" && meson_option_add "--wrap-mode=nodownload"
1945 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
1946 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
1947 test "$static" = yes && meson_option_add -Dprefer_static=true
1948 test "$pie" = no && meson_option_add -Db_pie=false
1949 test "$werror" = yes && meson_option_add -Dwerror=true
1950
1951 # QEMU options
1952 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
1953 test "$docs" != auto && meson_option_add "-Ddocs=$docs"
1954 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
1955 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
1956 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
1957 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
1958 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
1959 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
1960 run_meson() {
1961 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
1962 }
1963 eval run_meson $meson_options
1964 if test "$?" -ne 0 ; then
1965 error_exit "meson setup failed"
1966 fi
1967 else
1968 if test -f meson-private/cmd_line.txt; then
1969 # Adjust old command line options that were removed
1970 # sed -i is not portable
1971 perl -i -ne '
1972 /^sphinx_build/ && next;
1973 print;' meson-private/cmd_line.txt
1974 fi
1975 fi
1976
1977 # Save the configure command line for later reuse.
1978 cat <<EOD >config.status
1979 #!/bin/sh
1980 # Generated by configure.
1981 # Run this file to recreate the current configuration.
1982 # Compiler output produced by configure, useful for debugging
1983 # configure, is in config.log if it exists.
1984 EOD
1985
1986 preserve_env() {
1987 envname=$1
1988
1989 eval envval=\$$envname
1990
1991 if test -n "$envval"
1992 then
1993 echo "$envname='$envval'" >> config.status
1994 echo "export $envname" >> config.status
1995 else
1996 echo "unset $envname" >> config.status
1997 fi
1998 }
1999
2000 # Preserve various env variables that influence what
2001 # features/build target configure will detect
2002 preserve_env AR
2003 preserve_env AS
2004 preserve_env CC
2005 preserve_env CFLAGS
2006 preserve_env CXX
2007 preserve_env CXXFLAGS
2008 preserve_env LD
2009 preserve_env LDFLAGS
2010 preserve_env LD_LIBRARY_PATH
2011 preserve_env NM
2012 preserve_env OBJCFLAGS
2013 preserve_env OBJCOPY
2014 preserve_env PATH
2015 preserve_env PKG_CONFIG
2016 preserve_env PKG_CONFIG_LIBDIR
2017 preserve_env PKG_CONFIG_PATH
2018 preserve_env PYTHON
2019 preserve_env QEMU_GA_MANUFACTURER
2020 preserve_env QEMU_GA_DISTRO
2021 preserve_env QEMU_GA_VERSION
2022 preserve_env SDL2_CONFIG
2023 preserve_env SMBD
2024 preserve_env STRIP
2025 preserve_env WIDL
2026 preserve_env WINDRES
2027 preserve_env WINDMC
2028
2029 printf "exec" >>config.status
2030 for i in "$0" "$@"; do
2031 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2032 done
2033 echo ' "$@"' >>config.status
2034 chmod +x config.status
2035
2036 rm -r "$TMPDIR1"